-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.AddCombo = function(num,cut,maximum,pos,x,y,space,smooth)
	num = num or 5
	cut = cut or num
	maximum = maximum or num
	pos = pos or {"BOTTOM",Heddframe,"TOP",0,20}
	x=lib.realX(x or 5)
	y=lib.realY(y or 10)
	space = lib.realX(space or 2)
	smooth = smooth or {0,1,0, 1,1,0, 1,0,0}
	Heddframe.combo = Heddframe.combo or CreateFrame("Frame","$parent_Combo",Heddframe)
	--Heddframe.combo:SetScale(1 / UIParent:GetScale())
--	Heddframe.combo:Show()
	Heddframe.combo.max=maximum
	Heddframe.combo.num_show=num
	Heddframe.combo.num=0
	Heddframe.combo:SetHeight(y)
	Heddframe.combo:SetWidth((x+space)*num-space)
	Heddframe.combo:SetPoint(unpack(pos))
	Heddframe.combo.current=Heddframe.combo.current or {}
	Heddframe.combo.background=Heddframe.combo.background or {}
	for i=1, num do
		Heddframe.combo.background[i] = Heddframe.combo.background[i] or Heddframe.combo:CreateTexture("$parent_"..i, "BACKGROUND")
		Heddframe.combo.background[i]:SetHeight(y)
		Heddframe.combo.background[i]:SetWidth(x)
		Heddframe.combo.background[i]:SetTexture(cfg.statusbar_texture)
		Heddframe.combo.background[i]:SetPoint("BOTTOMLEFT",Heddframe.combo,"BOTTOMLEFT",(x+space)*(i-1),0)
		--Heddframe.combo.background[i]:SetVertexColor(hedlib.ColorGradient((i-1)%cut/(cut-1),unpack(smooth)))
		hedlib.SetDesaturation(Heddframe.combo.background[i],true)
		Heddframe.combo.background[i]:SetAlpha(0.3)
		Heddframe.combo.background[i]:Show()
		
		Heddframe.combo.current[i] = Heddframe.combo.current[i] or Heddframe.combo:CreateTexture("$parent_"..i, "OVERLAY")
		Heddframe.combo.current[i]:SetHeight(y)
		Heddframe.combo.current[i]:SetWidth(x)
		Heddframe.combo.current[i]:SetTexture(cfg.statusbar_texture)
		Heddframe.combo.current[i]:SetPoint("BOTTOMLEFT",Heddframe.combo,"BOTTOMLEFT",(x+space)*(i-1),0)
		Heddframe.combo.current[i]:SetVertexColor(hedlib.ColorGradient((i-1)/(cut-1),unpack(smooth)))
		Heddframe.combo.current[i]:Hide()
		
		Heddframe.combo.text=Heddframe.combo.text or hedlib.CreateFont(Heddframe.combo, cfg.textfont, nil, "OUTLINE")
		Heddframe.combo.text:SetPoint("RIGHT",Heddframe.combo,"LEFT")
	end
	lib.Hedd_slash("combo "..HeddDB.combo)
	--return Heddframe.combo
end

lib.AddResource = function(num,pos,x,y,space,smooth)
	num = num or 5
	pos = pos or {"BOTTOM",Heddframe,"TOP",0,20}
	x=lib.realX(x or 5)
	y=lib.realY(y or 10)
	space = lib.realX(space or 2)
	x=x*10+space*9
	Heddframe.resource = Heddframe.resource or CreateFrame("Frame","$parent_Resource",Heddframe)
	Heddframe.resource.max=num
	Heddframe.resource.num=0
	Heddframe.resource:SetHeight(y)
	Heddframe.resource:SetWidth(x)
	Heddframe.resource:SetPoint(unpack(pos))
	Heddframe.resource.background=Heddframe.resource.background or Heddframe.resource:CreateTexture("$parent_background", "BACKGROUND")
	Heddframe.resource.background:SetAllPoints(Heddframe.resource)
	Heddframe.resource.background:SetTexture(cfg.statusbar_texture)
	hedlib.SetDesaturation(Heddframe.resource.background,true)
	Heddframe.resource.background:SetAlpha(0.3)
	Heddframe.resource.background:Show()
	
	Heddframe.resource.bar=Heddframe.resource.bar or CreateFrame("StatusBar", "$parent_BAR", Heddframe)
	Heddframe.resource.bar:SetAllPoints(Heddframe.resource)
	Heddframe.resource.bar:SetStatusBarTexture(cfg.statusbar_texture)
	
	--Heddframe.resource.bar:SetStatusBarColor(124/255, 252/255, 0)
	Heddframe.resource.bar:SetMinMaxValues(0, Heddframe.resource.max)
	Heddframe.resource.smooth = smooth or {0,1,0, 1,1,0, 1,0,0}
	Heddframe.resource.bar:SetStatusBarColor(hedlib.ColorGradient(Heddframe.resource.num/Heddframe.resource.max,unpack(Heddframe.resource.smooth)))
	--Heddframe.resource.bar:SetReverseFill(true)
	Heddframe.resource.bar:SetValue(0)
	Heddframe.resource.text=Heddframe.resource.text or hedlib.CreateFont(Heddframe.resource, cfg.textfont, nil, "OUTLINE")
	Heddframe.resource.text:SetPoint("RIGHT",Heddframe.resource,"LEFT")
	Heddframe.resource.bar:Show()
end

lib.SetResource = function(num,pos,x,y,space,smooth)
	lib.HideCombo()
	lib.AddResource(num,pos,x,y,space,smooth)
	
end

lib.SetTypeResource = function(tp)
	if Heddframe.resource then
		Heddframe.resource.altpower=false
		Heddframe.resource.type=tp
	end
end
lib.UpdateResource = function(num)
	if Heddframe.resource then
		Heddframe.resource.num=num
		Heddframe.resource.bar:SetValue(num)
		Heddframe.resource.bar:SetStatusBarColor(hedlib.ColorGradient(Heddframe.resource.num/Heddframe.resource.max,unpack(Heddframe.resource.smooth)))
		Heddframe.resource.text:SetText(num>0 and num or "")
	end
end

lib.UpdateCombo = function(num)
	if Heddframe.combo then
		Heddframe.combo.num=num
		for i=1,Heddframe.combo.max do
			if i<=num then
				Heddframe.combo.current[i]:Show()
			else
				Heddframe.combo.current[i]:Hide()
			end
		end
		Heddframe.combo.text:SetText(num>0 and num or "")
	end
end

lib.GetComboMax = function()
	if Heddframe.combo then
		return Heddframe.combo.max
	else
		return 0
	end
end

lib.GetComboNum = function()
	if Heddframe.combo then
		return Heddframe.combo.num
	else
		return 0
	end
end

lib.HideCombo = function()
	lib.HideFrame(Heddframe.combo)
	if not Heddframe.combo or not Heddframe.combo.current then return end
	i=1
	while true do
		if not Heddframe.combo.current[i] then
			Heddframe.combo.altpower=false
			return
		else
			Heddframe.combo.current[i]:Hide()
			Heddframe.combo.background[i]:Hide()
		end
		i=i+1
	end
end

lib.HideResource = function()
	if not Heddframe.resource then return end
	lib.HideFrame(Heddframe.resource)
	Heddframe.resource.bar:Hide()
	Heddframe.resource.background:Hide()
	Heddframe.resource.altpower=false
	Heddframe.resource.type=nil
end
